/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CSP_CREATOR;

import LOGIC.ObjectList;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author sarah
 */
public class CreatorBehaviorProtocol {

    private ObjectList listObj;
    private CreatorTypesAndChannels createTC;
    private String cspprotocol = "";
    private String prot;
    private String dual_prot;

    public CreatorBehaviorProtocol(ObjectList obl, String prot, String dual_prot) {

        listObj = obl;
        createTC = new CreatorTypesAndChannels(obl);
        this.prot = prot;
        this.dual_prot = dual_prot;
    }

    public void createBehaviorProtocol() {

      
        
        createTC.creatorTypesChannels();

        cspprotocol = cspprotocol + "\n";

        //declaração de processos auxiliares


        cspprotocol = cspprotocol + "\n" + listObj.getProcessosAuxiliares();

        cspprotocol = cspprotocol + "\n\n";
        
        
        
        if(prot.contains("=")){
            int s = prot.indexOf("=");
            
            cspprotocol = cspprotocol + prot + "\n\n";
            cspprotocol = cspprotocol + "RECEBE_PROT = " + prot.substring(0, s -1) + "\n\n";
            //setando processos que foram declarados na janela de protocolos
            listObj.setProcessosAuxiliares(listObj.getProcessosAuxiliares() +"\n"+ prot);
        }else{
            cspprotocol = cspprotocol + "RECEBE_PROT = " + prot + "\n\n";
        }
        if(dual_prot.contains("=")){
            int st = dual_prot.indexOf("=");
            
            cspprotocol = cspprotocol +  dual_prot + "\n\n";
            cspprotocol = cspprotocol + "RECEBE_DUAL_PROT = " + dual_prot.substring(0, st-1) + "\n";
            //setando processos que foram declarados na janela de protocolos
            listObj.setProcessosAuxiliares(listObj.getProcessosAuxiliares() + "\n"+ dual_prot);
        }else{
            cspprotocol = cspprotocol + "RECEBE_DUAL_PROT = " + dual_prot + "\n";
        }
        

        //cria arquivo para escrita do comportamento q será verificado pelo Checker
        FileWriter Wcsp = null;
        try {
            Wcsp = new FileWriter(new File("cspFiles/Comportamento.csp"));

            PrintWriter d = new PrintWriter(Wcsp);
            d.flush();
            // escreve no arquivo os tipos e canais que estão na string 'csp, em seguida escreve uma string com o
            // comportamento que é recebido do comtrato
            d.write(createTC.getTypeChannel() + "\n\n" + cspprotocol);
            Wcsp.close();
            d.close();
        } catch (IOException ex) {
            System.out.println("não estou gerando nenhuma exceção");

        }

    }
}
