/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CSP_CREATOR;

import LOGIC.BoolType;
import LOGIC.Channel;
import LOGIC.Datatype;
import LOGIC.IntervalType;
import LOGIC.ObjectList;
import LOGIC.Type;

/**
 *
 * @author sarah
 */
public class CreatorTypesAndChannels {
    
    private ObjectList obl;
    private String typeChannel = "";

    public CreatorTypesAndChannels( ObjectList l) {
        obl = l;
    }

    public String getTypeChannel() {
        return typeChannel;
    }

    public void setTypeChannel(String typeChannel) {
        this.typeChannel = typeChannel;
    }
    
    public void creatorTypesChannels(){
        
        setTypeChannel("");
        
        for (int i = 0; i < obl.getTypeList().size(); i++) {//para declarar todos os tipos contidos em ObjectList

            typeInstanciation(obl.getTypeList().get(i));
        }

        for (int i = 0; i < obl.getChannelList().size(); i++) {

            channelInstanciation(obl.getChannelList().get(i));
            
        }
    }
    
    public void typeInstanciation(Type tipo) {


        if (tipo instanceof BoolType) {
            setTypeChannel(getTypeChannel() + "\n" + tipo.getNome() + " = Bool");

        }
        // verificando se 'tipo é do tipo 'IntervalType
        if (tipo instanceof IntervalType) {
            //instanciando interval
            IntervalType interval = (IntervalType) tipo;
            setTypeChannel(getTypeChannel() + "\n" + tipo.getNome() + " = {" + interval.getMim() + ".." + interval.getMax() + "}");

        }

        if (tipo instanceof Datatype) {
            setTypeChannel(getTypeChannel() + "\n" + "datatype " + tipo.getNome() + " = ");
            //instanciando Datatype
            Datatype datatype = (Datatype) tipo;
            int j;
            for (j = 0; j < datatype.getDatatype().size(); j++) {
                if (j != 0) {
                    setTypeChannel(getTypeChannel() + " | ");
                }
                if (!datatype.getDatatype().get(j).getType().equals("")) {
                    setTypeChannel(getTypeChannel() + datatype.getDatatype().get(j).getName() + "." + datatype.getDatatype().get(j).getType());
                } else {
                    setTypeChannel(getTypeChannel() + datatype.getDatatype().get(j).getName());

                }
            }

        }
    }

    public void channelInstanciation(Channel Canal) {

        setTypeChannel(getTypeChannel() + "\nchannel " + Canal.getName() + " : ");
        for (int i = 0; i < Canal.getType().size(); i++) {
            if (i == Canal.getType().size() - 1) {
                setTypeChannel(getTypeChannel() + Canal.getType().get(i).getNome());
            } else {
                setTypeChannel(getTypeChannel() + Canal.getType().get(i).getNome() + ".");
            }
        }
    }
    
}
