/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package LOGIC;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author sarah
 */
public class Channel implements Serializable{
    private String name;
    private List<Type> type;
    private String flag;

    public String getFlag() {
        return flag;
    }

    public void setFlag(String flag) {
        this.flag = flag;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Type> getType() {
        return type;
    }

    public void setType(List<Type> type) {
        this.type = type;
    }
    
    public Channel(){
        this.name = name;
        this.type = type;
    }
    
     public static void serializaLista(LinkedList<Channel> lista, String arquivo) {
	FileOutputStream arq = null;
	ObjectOutputStream out = null;
	try {
		//arquivo no qual os dados vao ser gravados
		arq = new FileOutputStream(arquivo);
 
		//objeto que vai escrever os dados
		out = new ObjectOutputStream(arq);
 
		//escreve todos os dados
		out.writeObject(lista);
	} catch (IOException ex) {
		ex.printStackTrace();
	} finally {
		try {
			arq.close();
			out.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
    }
        
    public static LinkedList<Channel> deserializaLista(String arquivo) {
	FileInputStream arqLeitura = null;
	ObjectInputStream in = null;
	LinkedList<Channel> lista = null;
	try {
		//arquivo onde estao os dados serializados
		arqLeitura = new FileInputStream(arquivo);
 
		//objeto que vai ler os dados do arquivo
		in = new ObjectInputStream(arqLeitura);
 
		//recupera os dados
		lista = (LinkedList<Channel>) in.readObject();
	} catch (ClassNotFoundException ex) {
		ex.printStackTrace();
	} catch (IOException ex) {
		ex.printStackTrace();
	} finally {
		try {
			arqLeitura.close();
			in.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
 
	return lista;
    }
   
}
