/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CREATOR_CONDICTIONS_RULES;

import LOGIC.Instance;
import LOGIC.Protocols;
import java.util.LinkedList;

/**
 *
 * @author sarah
 */
public class CreatorConditionAuto_Injection_Compatible {

    private Instance instance;
    private LinkedList<Protocols> prot;
    private String auto_injection = "";
    private LinkedList<String> LR;
    private String eventoprotocol1 = "";
    private String eventoprotocol2 = "";

    public CreatorConditionAuto_Injection_Compatible(Instance i, LinkedList<Protocols> listProtocols) {

        LR = new LinkedList<>();
        instance = i;
        prot = listProtocols;
        LR.add(instance.getName() + "_LR1");
        LR.add(instance.getName() + "_LR2");

        //pegando o nome do evento que passei por paramentro no protocolo 
        int pr1, pr2, pr3, pr4;

        pr1 = listProtocols.get(0).getProtocol().indexOf("(");
        pr2 = listProtocols.get(0).getProtocol().lastIndexOf(")");
        eventoprotocol1 = listProtocols.get(0).getProtocol().substring(pr1 + 1, pr2);

        pr3 = listProtocols.get(1).getProtocol().indexOf("(");
        pr4 = listProtocols.get(1).getProtocol().lastIndexOf(")");
        eventoprotocol2 = listProtocols.get(1).getProtocol().substring(pr3 + 1, pr4);
    }

    public String condictionAuto_Injection_Compatible() {

        //CRingCell_2_LR1 = <(write.3.req.v, wrt_i.3.req.v) | v <- seq(Value)>
        //CRingCell_2_LR2 = <(wrt_i.3.ack.v, write.3.ack.v) | v <- seq(Value)>

        //LR1 
        auto_injection = auto_injection + LR.get(0) + " = <(";
        auto_injection = auto_injection + eventoprotocol1 + ".e,";
        auto_injection = auto_injection + eventoprotocol2 + ".e) | ";
        auto_injection = auto_injection + "e <- seq(extensions(" + eventoprotocol1 + ")),";
        auto_injection = auto_injection + "\n";
        auto_injection = auto_injection + "\t\t member(" + eventoprotocol1 + ".e,";
        auto_injection = auto_injection + "outputsC(" + eventoprotocol1 + "," + instance.getName() + ")),";
        auto_injection = auto_injection + "\n";
        auto_injection = auto_injection + "\t\t member(" + eventoprotocol2 + ".e,";
        auto_injection = auto_injection + "inputsC(" + eventoprotocol2 + "," + instance.getName() + "))>";
        auto_injection = auto_injection + "\n\n";

        //LR2 
        auto_injection = auto_injection + LR.get(1) + " = <(";
        auto_injection = auto_injection + eventoprotocol2 + ".e,";
        auto_injection = auto_injection + eventoprotocol1 + ".e) | ";
        auto_injection = auto_injection + "e <- seq(extensions(" + eventoprotocol2 + ")),";
        auto_injection = auto_injection + "\n";
        auto_injection = auto_injection + "\t\t member(" + eventoprotocol2 + ".e,";
        auto_injection = auto_injection + "outputsC(" + eventoprotocol2 + "," + instance.getName() + ")),";
        auto_injection = auto_injection + "\n";
        auto_injection = auto_injection + "\t\t member(" + eventoprotocol1 + ".e,";
        auto_injection = auto_injection + "inputsC(" + eventoprotocol1 + "," + instance.getName() + "))>";
        auto_injection = auto_injection + "\n\n";



        //assert PROJECTION(CRingCell_2, {write.3, wrt_i.3}) [| {| write.3, wrt_i.3 |} |] 
        //BUFF_IO_1(CRingCell_2_LR1, CRingCell_2_LR2):[deadlock free [F]]
        auto_injection = auto_injection + "assert PROJECTION("
                + instance.getName() + ", {" + eventoprotocol1 + ", "
                + eventoprotocol2 + "}) [| {| "
                + eventoprotocol1 + ", " + eventoprotocol2
                + " |} |] BUFF_IO_1(" + LR.get(0) + ", " + LR.get(1)
                + "):[deadlock free [F]]";
        auto_injection = auto_injection + "\n\n";

        return auto_injection;
    }
}
