/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CSP_ANALYSE;

import CSP_ANALYSE.AnalyseFDR;
import CSP_ANALYSE.AnalyseChecker;
import CSP_CREATOR.CreatorBehaviorChecker;
import CSP_CREATOR.CreatorContract;
import LOGIC.Contract;
import LOGIC.ObjectList;
import java.util.ArrayList;

/**
 *
 * @author sarah
 */
public class CSPVerificationContract {

    private CreatorBehaviorChecker cspC;
    private AnalyseFDR analyseFdr;
    private AnalyseChecker analyseChecker;
    private CreatorContract creatC;
    
    public CSPVerificationContract(Contract c, ObjectList l) {
        
        cspC = new CreatorBehaviorChecker(c,l);
        cspC.CSPCheckerCreator();
        
        creatC = new CreatorContract(c, l);
        creatC.CSPFDRCreator();
        analyseChecker = new AnalyseChecker();
        analyseFdr = new AnalyseFDR(c, l);
    }

    public CheckerResult verificaBehaviorChecker() {

        
        return analyseChecker.takeResultChecher();
    }

    public ArrayList<FDRResult> verificaContractIsIOprocess() {

        //passo o contrato para o analyseFDR
        
        return analyseFdr.takeResultIOProcess();
        
    }
    
 
}
