/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CSP_CREATOR;

import LOGIC.Contract;

/**
 *
 * @author sarah
 */
public class CreatorIOProcess {

    private Contract contract;
    private String ioprocess;

    public CreatorIOProcess(Contract c) {
        contract = c;
    }

    public String getIoprocess() {
        return ioprocess;
    }

    public void setIoprocess(String ioprocess) {
        this.ioprocess = ioprocess;
    }

    public void creatorIOProcess() {
        setIoprocess("");
        // condições para verificação de IOprocess
        setIoprocess(getIoprocess() + "\n--Condition A.1: Alphabets are disjont");
        setIoprocess(getIoprocess() + "\n--assert STOP [T= RUN(inter(events(" + contract.getName() + "),events(" + contract.getName() + ")))");
        setIoprocess(getIoprocess() + "\n\n--Condition A.2: I/O Process");
        setIoprocess(getIoprocess() + "\n--Condition A.2.1: Every channel in P is an I/O Channel");
        setIoprocess(getIoprocess() + "\nassert not Test(inter(inputs(" + contract.getName() + "),outputs(" + contract.getName() + ")) == {}) [T= ERROR");
        setIoprocess(getIoprocess() + "\n\n--Condition A.2.2: The contract has infinite set of traces");
        setIoprocess(getIoprocess() + "\nassert not HideAll(" + contract.getName() + "):[divergence free [FD]]");
        setIoprocess(getIoprocess() + "\n\n--Condition A.2.3: The contract is divergence-free");
        setIoprocess(getIoprocess() + "\nassert " + contract.getName() + ":[divergence free [FD]]");
        setIoprocess(getIoprocess() + "\n\n--Condition A.2.4: The contract is input deterministic");
        setIoprocess(getIoprocess() + "\nassert LHS_InputDet(" + contract.getName() + ") [F= RHS_InputDet(" + contract.getName() + ")");
        setIoprocess(getIoprocess() + "\n\n--Condition A.2.5: The contract is strong output decisive");
        setIoprocess(getIoprocess() + "\nassert LHS_OutputDec_A(" + contract.getName() + ") [F= RHS_OutputDec_A(" + contract.getName() + ")");

        for (int i = 0; i < contract.getChannel().size(); i++) {

            setIoprocess(getIoprocess() + "\nassert LHS_OutputDec_B(" + contract.getName() + "," + contract.getChannel().get(i).getName() + ") [F= RHS_OutputDec_B(" + contract.getName() + "," + contract.getChannel().get(i).getName() + ")");

        }

    }
}
