package LOGIC;



import java.util.Locale;
import java.util.ResourceBundle;

public class Internacional{

	String linguagem;
	String pais;
	Locale localizacao;
	ResourceBundle mensagens;


	public Internacional(String linguagem, String pais) {
		this.linguagem = linguagem;
		this.pais = pais;
		this.localizacao = new Locale(linguagem, pais);
		this.mensagens = ResourceBundle.getBundle("MessagesBundle", localizacao);
	}
	public Locale getLocalizacao() {
		return this.localizacao;
	}
	public String retornarMensagem(String codigo) {
		String mensagem = mensagens.getString(codigo);
		return mensagem;
	}
}
